Index: sansmodels/src/c_models/hollowcylinder.cpp
===================================================================
--- sansmodels/src/c_models/hollowcylinder.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/hollowcylinder.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -18,32 +18,117 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "hollow_cylinder.h"
 
 extern "C" {
-	#include "libCylinder.h"
-	#include "libStructureFactor.h"
-	#include "hollow_cylinder.h"
+#include "libCylinder.h"
+#include "libStructureFactor.h"
+}
+
+typedef struct {
+  double scale;
+  double core_radius;
+  double radius;
+  double length;
+  double sldCyl;
+  double sldSolv;
+  double background;
+  double axis_theta;
+  double axis_phi;
+} HollowCylinderParameters;
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the hollow cylinder
+ * @param q: q-value
+ * @param q_x: q_x / q
+ * @param q_y: q_y / q
+ * @return: function value
+ */
+static double hollow_cylinder_analytical_2D_scaled(HollowCylinderParameters *pars, double q, double q_x, double q_y) {
+  double cyl_x, cyl_y, cyl_z;
+  double q_z;
+  double  alpha,vol, cos_val;
+  double answer;
+  //convert angle degree to radian
+  double pi = 4.0*atan(1.0);
+  double theta = pars->axis_theta * pi/180.0;
+  double phi = pars->axis_phi * pi/180.0;
+
+  // Cylinder orientation
+  cyl_x = sin(theta) * cos(phi);
+  cyl_y = sin(theta) * sin(phi);
+  cyl_z = cos(theta);
+
+  // q vector
+  q_z = 0;
+
+  // Compute the angle btw vector q and the
+  // axis of the cylinder
+  cos_val = cyl_x*q_x + cyl_y*q_y + cyl_z*q_z;
+
+  // The following test should always pass
+  if (fabs(cos_val)>1.0) {
+    printf("core_shell_cylinder_analytical_2D: Unexpected error: cos(alpha)=%g\n", cos_val);
+    return 0;
+  }
+
+  alpha = acos( cos_val );
+
+  // Call the IGOR library function to get the kernel
+  answer = HolCylKernel(q, pars->core_radius, pars->radius, pars->length, cos_val);
+
+  // Multiply by contrast^2
+  answer *= (pars->sldCyl - pars->sldSolv)*(pars->sldCyl - pars->sldSolv);
+
+  //normalize by cylinder volume
+  vol=pi*((pars->radius*pars->radius)-(pars->core_radius *pars->core_radius))
+          *(pars->length);
+  answer *= vol;
+
+  //convert to [cm-1]
+  answer *= 1.0e8;
+
+  //Scale
+  answer *= pars->scale;
+
+  // add in the background
+  answer += pars->background;
+
+  return answer;
+}
+
+
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the Hollow cylinder
+ * @param q: q-value
+ * @return: function value
+ */
+static double hollow_cylinder_analytical_2DXY(HollowCylinderParameters *pars, double qx, double qy) {
+  double q;
+  q = sqrt(qx*qx+qy*qy);
+  return hollow_cylinder_analytical_2D_scaled(pars, q, qx/q, qy/q);
 }
 
 HollowCylinderModel :: HollowCylinderModel() {
-	scale      = Parameter(1.0);
-	core_radius = Parameter(20.0, true);
-	core_radius.set_min(0.0);
-	radius  = Parameter(30.0, true);
-	radius.set_min(0.0);
-	length     = Parameter(400.0, true);
-	length.set_min(0.0);
-	sldCyl  = Parameter(6.3e-6);
-	sldSolv  = Parameter(1.0e-6);
-	background = Parameter(0.0);
-	axis_theta = Parameter(0.0, true);
-	axis_phi   = Parameter(0.0, true);
+  scale      = Parameter(1.0);
+  core_radius = Parameter(20.0, true);
+  core_radius.set_min(0.0);
+  radius  = Parameter(30.0, true);
+  radius.set_min(0.0);
+  length     = Parameter(400.0, true);
+  length.set_min(0.0);
+  sldCyl  = Parameter(6.3e-6);
+  sldSolv  = Parameter(1.0e-6);
+  background = Parameter(0.0);
+  axis_theta = Parameter(0.0, true);
+  axis_phi   = Parameter(0.0, true);
 }
 
@@ -55,67 +140,67 @@
  */
 double HollowCylinderModel :: operator()(double q) {
-	double dp[7];
-
-	dp[0] = scale();
-	dp[1] = core_radius();
-	dp[2] = radius();
-	dp[3] = length();
-	dp[4] = sldCyl();
-	dp[5] = sldSolv();
-	dp[6] = 0.0;
-
-	// Get the dispersion points for the core radius
-	vector<WeightPoint> weights_core_radius;
-	core_radius.get_weights(weights_core_radius);
-
-	// Get the dispersion points for the shell radius
-	vector<WeightPoint> weights_radius;
-	radius.get_weights(weights_radius);
-
-	// Get the dispersion points for the length
-	vector<WeightPoint> weights_length;
-	length.get_weights(weights_length);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double vol = 0.0;
-
-	// Loop over core radius weight points
-	for(int i=0; i< (int)weights_core_radius.size(); i++) {
-		dp[1] = weights_core_radius[i].value;
-
-		// Loop over length weight points
-		for(int j=0; j< (int)weights_length.size(); j++) {
-			dp[3] = weights_length[j].value;
-
-			// Loop over shell radius weight points
-			for(int k=0; k< (int)weights_radius.size(); k++) {
-				dp[2] = weights_radius[k].value;
-				//Un-normalize  by volume
-				sum += weights_core_radius[i].weight
-					* weights_length[j].weight
-					* weights_radius[k].weight
-					* HollowCylinder(dp, q)
-					* (pow(weights_radius[k].value,2)-pow(weights_core_radius[i].value,2))
-					* weights_length[j].value;
-				//Find average volume
-				vol += weights_core_radius[i].weight
-					* weights_length[j].weight
-					* weights_radius[k].weight
-					* (pow(weights_radius[k].value,2)-pow(weights_core_radius[i].value,2))
-					* weights_length[j].value;
-
-				norm += weights_core_radius[i].weight
-					* weights_length[j].weight
-					* weights_radius[k].weight;
-			}
-		}
-	}
-	if (vol != 0.0 && norm != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum/(vol/norm);}
-
-	return sum/norm + background();
+  double dp[7];
+
+  dp[0] = scale();
+  dp[1] = core_radius();
+  dp[2] = radius();
+  dp[3] = length();
+  dp[4] = sldCyl();
+  dp[5] = sldSolv();
+  dp[6] = 0.0;
+
+  // Get the dispersion points for the core radius
+  vector<WeightPoint> weights_core_radius;
+  core_radius.get_weights(weights_core_radius);
+
+  // Get the dispersion points for the shell radius
+  vector<WeightPoint> weights_radius;
+  radius.get_weights(weights_radius);
+
+  // Get the dispersion points for the length
+  vector<WeightPoint> weights_length;
+  length.get_weights(weights_length);
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double vol = 0.0;
+
+  // Loop over core radius weight points
+  for(int i=0; i< (int)weights_core_radius.size(); i++) {
+    dp[1] = weights_core_radius[i].value;
+
+    // Loop over length weight points
+    for(int j=0; j< (int)weights_length.size(); j++) {
+      dp[3] = weights_length[j].value;
+
+      // Loop over shell radius weight points
+      for(int k=0; k< (int)weights_radius.size(); k++) {
+        dp[2] = weights_radius[k].value;
+        //Un-normalize  by volume
+        sum += weights_core_radius[i].weight
+            * weights_length[j].weight
+            * weights_radius[k].weight
+            * HollowCylinder(dp, q)
+        * (pow(weights_radius[k].value,2)-pow(weights_core_radius[i].value,2))
+        * weights_length[j].value;
+        //Find average volume
+        vol += weights_core_radius[i].weight
+            * weights_length[j].weight
+            * weights_radius[k].weight
+            * (pow(weights_radius[k].value,2)-pow(weights_core_radius[i].value,2))
+            * weights_length[j].value;
+
+        norm += weights_core_radius[i].weight
+            * weights_length[j].weight
+            * weights_radius[k].weight;
+      }
+    }
+  }
+  if (vol != 0.0 && norm != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum/(vol/norm);}
+
+  return sum/norm + background();
 }
 
@@ -127,105 +212,105 @@
  */
 double HollowCylinderModel :: operator()(double qx, double qy) {
-	HollowCylinderParameters dp;
-	// Fill parameter array
-	dp.scale      = scale();
-	dp.core_radius     = core_radius();
-	dp.radius  = radius();
-	dp.length     = length();
-	dp.sldCyl   = sldCyl();
-	dp.sldSolv  = sldSolv();
-	dp.background = 0.0;
-	dp.axis_theta = axis_theta();
-	dp.axis_phi   = axis_phi();
-
-	// Get the dispersion points for the core radius
-	vector<WeightPoint> weights_core_radius;
-	core_radius.get_weights(weights_core_radius);
-
-	// Get the dispersion points for the shell radius
-	vector<WeightPoint> weights_radius;
-	radius.get_weights(weights_radius);
-
-	// Get the dispersion points for the length
-	vector<WeightPoint> weights_length;
-	length.get_weights(weights_length);
-
-	// Get angular averaging for theta
-	vector<WeightPoint> weights_theta;
-	axis_theta.get_weights(weights_theta);
-
-	// Get angular averaging for phi
-	vector<WeightPoint> weights_phi;
-	axis_phi.get_weights(weights_phi);
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-	double norm_vol = 0.0;
-	double vol = 0.0;
-	double pi = 4.0*atan(1.0);
-	// Loop over core radius weight points
-	for(int i=0; i<(int)weights_core_radius.size(); i++) {
-		dp.core_radius = weights_core_radius[i].value;
-
-
-		// Loop over length weight points
-		for(int j=0; j<(int)weights_length.size(); j++) {
-			dp.length = weights_length[j].value;
-
-			// Loop over shell radius weight points
-			for(int m=0; m< (int)weights_radius.size(); m++) {
-				dp.radius = weights_radius[m].value;
-
-			// Average over theta distribution
-			for(int k=0; k< (int)weights_theta.size(); k++) {
-				dp.axis_theta = weights_theta[k].value;
-
-				// Average over phi distribution
-				for(int l=0; l< (int)weights_phi.size(); l++) {
-					dp.axis_phi = weights_phi[l].value;
-					//Un-normalize by volume
-					double _ptvalue = weights_core_radius[i].weight
-						* weights_length[j].weight
-						* weights_radius[m].weight
-						* weights_theta[k].weight
-						* weights_phi[l].weight
-						* hollow_cylinder_analytical_2DXY(&dp, qx, qy)
-						/ ((pow(weights_radius[m].value,2)-pow(weights_core_radius[i].value,2))
-						* weights_length[j].value);
-					if (weights_theta.size()>1) {
-						_ptvalue *= fabs(sin(weights_theta[k].value * pi/180.0));
-					}
-					sum += _ptvalue;
-					//Find average volume
-					vol += weights_core_radius[i].weight
-						* weights_length[j].weight
-						* weights_radius[m].weight
-						* (pow(weights_radius[m].value,2)-pow(weights_core_radius[i].value,2))
-						* weights_length[j].value;
-					//Find norm for volume
-					norm_vol += weights_core_radius[i].weight
-						* weights_length[j].weight
-						* weights_radius[m].weight;
-
-					norm += weights_core_radius[i].weight
-						* weights_length[j].weight
-						* weights_radius[m].weight
-						* weights_theta[k].weight
-						* weights_phi[l].weight;
-
-				}
-			}
-			}
-		}
-	}
-	// Averaging in theta needs an extra normalization
-	// factor to account for the sin(theta) term in the
-	// integration (see documentation).
-	if (weights_theta.size()>1) norm = norm/asin(1.0);
-	if (vol != 0.0 || norm_vol != 0.0) {
-		//Re-normalize by avg volume
-		sum = sum*(vol/norm_vol);}
-	return sum/norm + background();
+  HollowCylinderParameters dp;
+  // Fill parameter array
+  dp.scale      = scale();
+  dp.core_radius     = core_radius();
+  dp.radius  = radius();
+  dp.length     = length();
+  dp.sldCyl   = sldCyl();
+  dp.sldSolv  = sldSolv();
+  dp.background = 0.0;
+  dp.axis_theta = axis_theta();
+  dp.axis_phi   = axis_phi();
+
+  // Get the dispersion points for the core radius
+  vector<WeightPoint> weights_core_radius;
+  core_radius.get_weights(weights_core_radius);
+
+  // Get the dispersion points for the shell radius
+  vector<WeightPoint> weights_radius;
+  radius.get_weights(weights_radius);
+
+  // Get the dispersion points for the length
+  vector<WeightPoint> weights_length;
+  length.get_weights(weights_length);
+
+  // Get angular averaging for theta
+  vector<WeightPoint> weights_theta;
+  axis_theta.get_weights(weights_theta);
+
+  // Get angular averaging for phi
+  vector<WeightPoint> weights_phi;
+  axis_phi.get_weights(weights_phi);
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+  double norm_vol = 0.0;
+  double vol = 0.0;
+  double pi = 4.0*atan(1.0);
+  // Loop over core radius weight points
+  for(int i=0; i<(int)weights_core_radius.size(); i++) {
+    dp.core_radius = weights_core_radius[i].value;
+
+
+    // Loop over length weight points
+    for(int j=0; j<(int)weights_length.size(); j++) {
+      dp.length = weights_length[j].value;
+
+      // Loop over shell radius weight points
+      for(int m=0; m< (int)weights_radius.size(); m++) {
+        dp.radius = weights_radius[m].value;
+
+        // Average over theta distribution
+        for(int k=0; k< (int)weights_theta.size(); k++) {
+          dp.axis_theta = weights_theta[k].value;
+
+          // Average over phi distribution
+          for(int l=0; l< (int)weights_phi.size(); l++) {
+            dp.axis_phi = weights_phi[l].value;
+            //Un-normalize by volume
+            double _ptvalue = weights_core_radius[i].weight
+                * weights_length[j].weight
+                * weights_radius[m].weight
+                * weights_theta[k].weight
+                * weights_phi[l].weight
+                * hollow_cylinder_analytical_2DXY(&dp, qx, qy)
+            / ((pow(weights_radius[m].value,2)-pow(weights_core_radius[i].value,2))
+                * weights_length[j].value);
+            if (weights_theta.size()>1) {
+              _ptvalue *= fabs(sin(weights_theta[k].value * pi/180.0));
+            }
+            sum += _ptvalue;
+            //Find average volume
+            vol += weights_core_radius[i].weight
+                * weights_length[j].weight
+                * weights_radius[m].weight
+                * (pow(weights_radius[m].value,2)-pow(weights_core_radius[i].value,2))
+                * weights_length[j].value;
+            //Find norm for volume
+            norm_vol += weights_core_radius[i].weight
+                * weights_length[j].weight
+                * weights_radius[m].weight;
+
+            norm += weights_core_radius[i].weight
+                * weights_length[j].weight
+                * weights_radius[m].weight
+                * weights_theta[k].weight
+                * weights_phi[l].weight;
+
+          }
+        }
+      }
+    }
+  }
+  // Averaging in theta needs an extra normalization
+  // factor to account for the sin(theta) term in the
+  // integration (see documentation).
+  if (weights_theta.size()>1) norm = norm/asin(1.0);
+  if (vol != 0.0 || norm_vol != 0.0) {
+    //Re-normalize by avg volume
+    sum = sum*(vol/norm_vol);}
+  return sum/norm + background();
 }
 
@@ -238,7 +323,7 @@
  */
 double HollowCylinderModel :: evaluate_rphi(double q, double phi) {
-	double qx = q*cos(phi);
-	double qy = q*sin(phi);
-	return (*this).operator()(qx, qy);
+  double qx = q*cos(phi);
+  double qy = q*sin(phi);
+  return (*this).operator()(qx, qy);
 }
 /**
@@ -247,42 +332,42 @@
  */
 double HollowCylinderModel :: calculate_ER() {
-	HollowCylinderParameters dp;
-
-	dp.radius  = radius();
-	dp.length     = length();
-
-	double rad_out = 0.0;
-
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
-
-	// Get the dispersion points for the major shell
-	vector<WeightPoint> weights_length;
-	length.get_weights(weights_length);
-
-	// Get the dispersion points for the minor shell
-	vector<WeightPoint> weights_radius ;
-	radius.get_weights(weights_radius);
-
-	// Loop over major shell weight points
-	for(int i=0; i< (int)weights_length.size(); i++) {
-		dp.length = weights_length[i].value;
-		for(int k=0; k< (int)weights_radius.size(); k++) {
-			dp.radius = weights_radius[k].value;
-			//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
-			sum +=weights_length[i].weight
-				* weights_radius[k].weight*DiamCyl(dp.length,dp.radius)/2.0;
-			norm += weights_length[i].weight* weights_radius[k].weight;
-		}
-	}
-	if (norm != 0){
-		//return the averaged value
-		rad_out =  sum/norm;}
-	else{
-		//return normal value
-		//Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
-		rad_out = DiamCyl(dp.length,dp.radius)/2.0;}
-
-	return rad_out;
-}
+  HollowCylinderParameters dp;
+
+  dp.radius  = radius();
+  dp.length     = length();
+
+  double rad_out = 0.0;
+
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
+
+  // Get the dispersion points for the major shell
+  vector<WeightPoint> weights_length;
+  length.get_weights(weights_length);
+
+  // Get the dispersion points for the minor shell
+  vector<WeightPoint> weights_radius ;
+  radius.get_weights(weights_radius);
+
+  // Loop over major shell weight points
+  for(int i=0; i< (int)weights_length.size(); i++) {
+    dp.length = weights_length[i].value;
+    for(int k=0; k< (int)weights_radius.size(); k++) {
+      dp.radius = weights_radius[k].value;
+      //Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+      sum +=weights_length[i].weight
+          * weights_radius[k].weight*DiamCyl(dp.length,dp.radius)/2.0;
+      norm += weights_length[i].weight* weights_radius[k].weight;
+    }
+  }
+  if (norm != 0){
+    //return the averaged value
+    rad_out =  sum/norm;}
+  else{
+    //return normal value
+    //Note: output of "DiamCyl(dp.length,dp.radius)" is DIAMETER.
+    rad_out = DiamCyl(dp.length,dp.radius)/2.0;}
+
+  return rad_out;
+}
Index: sansmodels/src/c_models/lamellar.cpp
===================================================================
--- sansmodels/src/c_models/lamellar.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/lamellar.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -18,16 +18,39 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "lamellar.h"
 
-extern "C" {
-//	#include "libCylinder.h"
-	#include "lamellar.h"
+/*  LamellarFFX  :  calculates the form factor of a lamellar structure - no S(q) effects included
+            -NO polydispersion included
+*/
+static double lamellar_kernel(double dp[], double q){
+  double scale,del,sld_bi,sld_sol,contr,bkg;    //local variables of coefficient wave
+  double inten, qval,Pq;
+  double Pi;
+
+
+  Pi = 4.0*atan(1.0);
+  scale = dp[0];
+  del = dp[1];
+  sld_bi = dp[2];
+  sld_sol = dp[3];
+  bkg = dp[4];
+  qval = q;
+  contr = sld_bi -sld_sol;
+
+  Pq = 2.0*contr*contr/qval/qval*(1.0-cos(qval*del));
+
+  inten = 2.0*Pi*scale*Pq/(qval*qval);    //this is now dimensionless...
+
+  inten /= del;     //normalize by the thickness (in A)
+
+  inten *= 1.0e8;   // 1/A to 1/cm
+
+  return(inten+bkg);
 }
 
@@ -39,5 +62,4 @@
 	sld_sol    = Parameter(6.3e-6);
 	background = Parameter(0.0);
-
 }
 
Index: sansmodels/src/c_models/lamellarFF_HG.cpp
===================================================================
--- sansmodels/src/c_models/lamellarFF_HG.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/lamellarFF_HG.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -18,28 +18,26 @@
  *   sansmodels/src/libigor
  *
- *	TODO: refactor so that we pull in the old sansmodels.c_extensions
  */
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "lamellarFF_HG.h"
 
 extern "C" {
-	#include "libCylinder.h"
-	#include "lamellarFF_HG.h"
+#include "libCylinder.h"
 }
 
 LamellarFFHGModel :: LamellarFFHGModel() {
-	scale      = Parameter(1.0);
-	t_length     = Parameter(15.0, true);
-	t_length.set_min(0.0);
-	h_thickness    = Parameter(10.0, true);
-	h_thickness.set_min(0.0);
-	sld_tail   = Parameter(4e-7);
-	sld_head  = Parameter(3e-6);
-	sld_solvent    = Parameter(6e-6);
-	background = Parameter(0.0);
+  scale      = Parameter(1.0);
+  t_length     = Parameter(15.0, true);
+  t_length.set_min(0.0);
+  h_thickness    = Parameter(10.0, true);
+  h_thickness.set_min(0.0);
+  sld_tail   = Parameter(4e-7);
+  sld_head  = Parameter(3e-6);
+  sld_solvent    = Parameter(6e-6);
+  background = Parameter(0.0);
 
 }
@@ -52,41 +50,41 @@
  */
 double LamellarFFHGModel :: operator()(double q) {
-	double dp[7];
+  double dp[7];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = t_length();
-	dp[2] = h_thickness();
-	dp[3] = sld_tail();
-	dp[4] = sld_head();
-	dp[5] = sld_solvent();
-	dp[6] = 0.0;
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = t_length();
+  dp[2] = h_thickness();
+  dp[3] = sld_tail();
+  dp[4] = sld_head();
+  dp[5] = sld_solvent();
+  dp[6] = 0.0;
 
-	// Get the dispersion points for the tail length
-	vector<WeightPoint> weights_t_length;
-	t_length.get_weights(weights_t_length);
+  // Get the dispersion points for the tail length
+  vector<WeightPoint> weights_t_length;
+  t_length.get_weights(weights_t_length);
 
-	// Get the dispersion points for the head thickness
-	vector<WeightPoint> weights_h_thickness;
-	h_thickness.get_weights(weights_h_thickness);
+  // Get the dispersion points for the head thickness
+  vector<WeightPoint> weights_h_thickness;
+  h_thickness.get_weights(weights_h_thickness);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
 
-	// Loop over semi axis A weight points
-	for(int i=0; i< (int)weights_t_length.size(); i++) {
-		dp[1] = weights_t_length[i].value;
+  // Loop over semi axis A weight points
+  for(int i=0; i< (int)weights_t_length.size(); i++) {
+    dp[1] = weights_t_length[i].value;
 
-		for (int j=0; j< (int)weights_h_thickness.size(); j++){
-			dp[2] = weights_h_thickness[j].value;
+    for (int j=0; j< (int)weights_h_thickness.size(); j++){
+      dp[2] = weights_h_thickness[j].value;
 
-			sum += weights_t_length[i].weight* weights_h_thickness[j].weight*LamellarFF_HG(dp, q);
-			norm += weights_t_length[i].weight* weights_h_thickness[j].weight;
-		}
+      sum += weights_t_length[i].weight* weights_h_thickness[j].weight*LamellarFF_HG(dp, q);
+      norm += weights_t_length[i].weight* weights_h_thickness[j].weight;
+    }
 
-	}
-	return sum/norm + background();
+  }
+  return sum/norm + background();
 }
 
@@ -99,6 +97,6 @@
 
 double LamellarFFHGModel :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -111,5 +109,5 @@
  */
 double LamellarFFHGModel :: evaluate_rphi(double q, double phi) {
-	return (*this).operator()(q);
+  return (*this).operator()(q);
 }
 /**
@@ -118,5 +116,5 @@
  */
 double LamellarFFHGModel :: calculate_ER() {
-//NOT implemented yet!!!
-	return 0.0;
+  //NOT implemented yet!!!
+  return 0.0;
 }
Index: sansmodels/src/c_models/lamellarPC.cpp
===================================================================
--- sansmodels/src/c_models/lamellarPC.cpp	(revision 67424cdc019bde2f4cbc089828ff660e6f914c2c)
+++ sansmodels/src/c_models/lamellarPC.cpp	(revision 82c11d354f0cffa7741bd2e74e0641e042eeb034)
@@ -20,25 +20,24 @@
 
 #include <math.h>
-#include "models.hh"
 #include "parameters.hh"
 #include <stdio.h>
 using namespace std;
+#include "lamellarPC.h"
 
 extern "C" {
-	#include "libCylinder.h"
-	#include "lamellarPC.h"
+#include "libCylinder.h"
 }
 
 LamellarPCrystalModel :: LamellarPCrystalModel() {
-	scale      = Parameter(1.0);
-	thickness     = Parameter(33.0, true);
-	thickness.set_min(0.0);
-	Nlayers    = Parameter(20.0, true);
-	Nlayers.set_min(0.0);
-	spacing   = Parameter(250);
-	pd_spacing   = Parameter(0.0);
-	sld_layer  = Parameter(1.0e-6);
-	sld_solvent    = Parameter(6.34e-6);
-	background = Parameter(0.0);
+  scale      = Parameter(1.0);
+  thickness     = Parameter(33.0, true);
+  thickness.set_min(0.0);
+  Nlayers    = Parameter(20.0, true);
+  Nlayers.set_min(0.0);
+  spacing   = Parameter(250);
+  pd_spacing   = Parameter(0.0);
+  sld_layer  = Parameter(1.0e-6);
+  sld_solvent    = Parameter(6.34e-6);
+  background = Parameter(0.0);
 
 }
@@ -51,41 +50,41 @@
  */
 double LamellarPCrystalModel :: operator()(double q) {
-	double dp[8];
+  double dp[8];
 
-	// Fill parameter array for IGOR library
-	// Add the background after averaging
-	dp[0] = scale();
-	dp[1] = thickness();
-	dp[2] = Nlayers();
-	dp[3] = spacing();
-	dp[4] = pd_spacing();
-	dp[5] = sld_layer();
-	dp[6] = sld_solvent();
-	dp[7] = 0.0; // Do not apply background here.
+  // Fill parameter array for IGOR library
+  // Add the background after averaging
+  dp[0] = scale();
+  dp[1] = thickness();
+  dp[2] = Nlayers();
+  dp[3] = spacing();
+  dp[4] = pd_spacing();
+  dp[5] = sld_layer();
+  dp[6] = sld_solvent();
+  dp[7] = 0.0; // Do not apply background here.
 
-	// Get the dispersion points for the head thickness
-	vector<WeightPoint> weights_thickness;
-	thickness.get_weights(weights_thickness);
+  // Get the dispersion points for the head thickness
+  vector<WeightPoint> weights_thickness;
+  thickness.get_weights(weights_thickness);
 
-	// Let's provide from the func which is more accurate especially for small q region.
-	// Get the dispersion points for the tail length
-	//vector<WeightPoint> weights_spacing;
-	//spacing.get_weights(weights_spacing);
+  // Let's provide from the func which is more accurate especially for small q region.
+  // Get the dispersion points for the tail length
+  //vector<WeightPoint> weights_spacing;
+  //spacing.get_weights(weights_spacing);
 
-	// Perform the computation, with all weight points
-	double sum = 0.0;
-	double norm = 0.0;
+  // Perform the computation, with all weight points
+  double sum = 0.0;
+  double norm = 0.0;
 
-	// Loop over thickness and spacing weight points
-	for(int i=0; i< (int)weights_thickness.size(); i++) {
-		dp[1] = weights_thickness[i].value;
-		//for (int j=0; j< (int)weights_spacing.size(); j++){
-			//dp[3] = weights_spacing[j].value;
-			sum += weights_thickness[i].weight*Lamellar_ParaCrystal(dp, q);
-			norm += weights_thickness[i].weight;
-		//}
-	}
-	//apply norm and background
-	return sum/norm + background();
+  // Loop over thickness and spacing weight points
+  for(int i=0; i< (int)weights_thickness.size(); i++) {
+    dp[1] = weights_thickness[i].value;
+    //for (int j=0; j< (int)weights_spacing.size(); j++){
+    //dp[3] = weights_spacing[j].value;
+    sum += weights_thickness[i].weight*Lamellar_ParaCrystal(dp, q);
+    norm += weights_thickness[i].weight;
+    //}
+  }
+  //apply norm and background
+  return sum/norm + background();
 }
 
@@ -98,6 +97,6 @@
 
 double LamellarPCrystalModel :: operator()(double qx, double qy) {
-	double q = sqrt(qx*qx + qy*qy);
-	return (*this).operator()(q);
+  double q = sqrt(qx*qx + qy*qy);
+  return (*this).operator()(q);
 }
 
@@ -110,5 +109,5 @@
  */
 double LamellarPCrystalModel :: evaluate_rphi(double q, double phi) {
-	return (*this).operator()(q);
+  return (*this).operator()(q);
 }
 /**
@@ -117,5 +116,5 @@
  */
 double LamellarPCrystalModel :: calculate_ER() {
-//NOT implemented yet!!!
-	return 0.0;
+  //NOT implemented yet!!!
+  return 0.0;
 }
